# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rocon_device_msgs/HueArray.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rocon_device_msgs.msg

class HueArray(genpy.Message):
  _md5sum = "ac7d5d01d5d83c6c14384ec4d7c8d7da"
  _type = "rocon_device_msgs/HueArray"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """Hue[] hue_list

================================================================================
MSG: rocon_device_msgs/Hue
int32 light_id
string type
string name
string modelid
string swvesion
HueState state
================================================================================
MSG: rocon_device_msgs/HueState
#pre-define color
string OFF = "OFF"
string WHITE = "WHITE"
string RED = "RED"
string GREEN = "GREEN"
string BLUE = "BLUE"
string YELLOW = "YELLOW"
string ORANGE = "ORANGE"
string MAGENTA = "MAGENTA"
string VIOLET = "VIOLET"

#light on/off status true:on /false:off
bool on 

#color coordination in HSV color space 
#http://en.wikipedia.org/wiki/HSL_and_HSV
uint16 hue #h
uint8 sat #s
uint8 bri #v

#light valid status - valid:on /invalid:off
bool reachable  

#for set color with pre-define color
string color"""
  __slots__ = ['hue_list']
  _slot_types = ['rocon_device_msgs/Hue[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       hue_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HueArray, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.hue_list is None:
        self.hue_list = []
    else:
      self.hue_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.hue_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.hue_list:
        buff.write(_get_struct_i().pack(val1.light_id))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.modelid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.swvesion
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.state
        _x = _v1
        buff.write(_get_struct_BH3B().pack(_x.on, _x.hue, _x.sat, _x.bri, _x.reachable))
        _x = _v1.color
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.hue_list is None:
        self.hue_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.hue_list = []
      for i in range(0, length):
        val1 = rocon_device_msgs.msg.Hue()
        start = end
        end += 4
        (val1.light_id,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.modelid = str[start:end].decode('utf-8')
        else:
          val1.modelid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.swvesion = str[start:end].decode('utf-8')
        else:
          val1.swvesion = str[start:end]
        _v2 = val1.state
        _x = _v2
        start = end
        end += 6
        (_x.on, _x.hue, _x.sat, _x.bri, _x.reachable,) = _get_struct_BH3B().unpack(str[start:end])
        _v2.on = bool(_v2.on)
        _v2.reachable = bool(_v2.reachable)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.color = str[start:end].decode('utf-8')
        else:
          _v2.color = str[start:end]
        self.hue_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.hue_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.hue_list:
        buff.write(_get_struct_i().pack(val1.light_id))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.modelid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.swvesion
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v3 = val1.state
        _x = _v3
        buff.write(_get_struct_BH3B().pack(_x.on, _x.hue, _x.sat, _x.bri, _x.reachable))
        _x = _v3.color
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.hue_list is None:
        self.hue_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.hue_list = []
      for i in range(0, length):
        val1 = rocon_device_msgs.msg.Hue()
        start = end
        end += 4
        (val1.light_id,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.modelid = str[start:end].decode('utf-8')
        else:
          val1.modelid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.swvesion = str[start:end].decode('utf-8')
        else:
          val1.swvesion = str[start:end]
        _v4 = val1.state
        _x = _v4
        start = end
        end += 6
        (_x.on, _x.hue, _x.sat, _x.bri, _x.reachable,) = _get_struct_BH3B().unpack(str[start:end])
        _v4.on = bool(_v4.on)
        _v4.reachable = bool(_v4.reachable)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.color = str[start:end].decode('utf-8')
        else:
          _v4.color = str[start:end]
        self.hue_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
_struct_BH3B = None
def _get_struct_BH3B():
    global _struct_BH3B
    if _struct_BH3B is None:
        _struct_BH3B = struct.Struct("<BH3B")
    return _struct_BH3B
